import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JPanel;

class MyCanvas extends JPanel implements MouseListener,MouseMotionListener{

	private static final long serialVersionUID = 5266543668946372212L;
	
	private int sirka; //z parent triedy
    private int vyska;
    private int hrubka;
    private skeleton parent;

    
    private boolean stlacena_mys;
    
    
	public MyCanvas(int sir, int vys,int hrubkaa, skeleton par){ //konstruktor
		System.out.print("MyCanvas Create" + "\n");
		
		sirka = sir;
		vyska = vys;
		hrubka = hrubkaa;
		parent = par;
		stlacena_mys = false;
		
		addMouseListener(this); //listener pre kliknutia a stlacenia tlacidiel mysky
		addMouseMotionListener(this); //listener pre pohyb myskou
		
	}

	//paint, vola sa pri repaint
	public void paint (Graphics g) {
		System.out.print("MyCanvas paint" + "\n");
		Graphics2D g2 =  (Graphics2D)g;
		vycisti(g2);
		if (parent.root_kost !=  null){
			parent.root_kost.kresli(g2,parent.oznacena, parent.animacia_oznacena);
		}
		if (parent.koza !=  null){
			parent.koza.kresli(g2,parent.oznacena_koza,parent.getmod(),true,0.0,0.0);
		}
		
	}
	
	//vycistenie plochy
	public void vycisti(Graphics2D g2){
		g2.setPaint(Color.white);
		g2.fillRect(0, 0, this.getWidth(), this.getHeight());
		
	}
	

	@Override
	public void mouseClicked(MouseEvent arg0) {
		//	
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		//
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		//
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		
		if (parent.mod == 0){
				kost oznac = null;
				if (parent.root_kost != null){
					oznac = parent.root_kost.oznacena(arg0.getPoint().getX(),arg0.getPoint().getY());
				}
				if (oznac != null){
					parent.oznacena = oznac;
					parent.oznacila_sa_kost();
					repaint();
					
				}else{
					if (parent.oznacena != null){
						
						double xn = parent.oznacena.getx() + parent.oznacena.getdlzka() * Math.cos(Math.toRadians(parent.oznacena.getuhol()));
				        double yn = parent.oznacena.gety() + parent.oznacena.getdlzka() * Math.sin(Math.toRadians(parent.oznacena.getuhol()));
						
						double ax = (xn - arg0.getPoint().getX()) * (xn - arg0.getPoint().getX());
						double ay = (yn - arg0.getPoint().getY()) * (yn - arg0.getPoint().getY());
						double dlzkaa =  Math.sqrt(ax + ay);
						
						double uholl = Math.atan2( arg0.getPoint().getY() - yn , arg0.getPoint().getX() - xn )* 180 / Math.PI;
						
		
						//System.out.print("xn:" + xn + "yn:" + yn);
						//System.out.print("uhol:" + uholl + "dlzka:" + dlzkaa);
						parent.pocet_kosti++;
						parent.oznacena.pridaj("kost_" + Integer.toString(parent.pocet_kosti), dlzkaa, hrubka,uholl,uholl+180-45,uholl+180+45, Color.black);
						repaint();
					}
				}
		}else if (parent.mod == 1){
			koza oznac = null;
			if (parent.koza != null){
				oznac = parent.koza.oznacena(arg0.getPoint().getX(),arg0.getPoint().getY());
			}
			if (oznac != null){
				parent.oznacena_koza = oznac;
				repaint();
				
			}else{
			
				//pri pridani koze oratat x a y oznacenej kosti
				koza koza_tmp = parent.koza;
				
				if (koza_tmp == null){
					parent.koza = new koza (arg0.getPoint().getX(),arg0.getPoint().getY(),0,0,true);
					
					double xn = arg0.getPoint().getX();//parent.oznacena.getx() + parent.oznacena.getdlzka() * Math.cos(Math.toRadians(parent.oznacena.getuhol()));
			        double yn = arg0.getPoint().getY();//parent.oznacena.gety() + parent.oznacena.getdlzka() * Math.sin(Math.toRadians(parent.oznacena.getuhol()));
			        double ax = (xn - arg0.getPoint().getX()) * (xn - arg0.getPoint().getX());
					double ay = (yn - arg0.getPoint().getY()) * (yn - arg0.getPoint().getY());
					double dlzkaa =  Math.sqrt(ax + ay);
					double uholl = Math.atan2( arg0.getPoint().getY() - yn , arg0.getPoint().getX() - xn )* 180 / Math.PI;
					parent.koza.pridaj_dalsiu(dlzkaa, uholl);
					
				}else{
					while (koza_tmp.getdalsia() != null){
						koza_tmp = koza_tmp.getdalsia();
					}
					
			        
			        double xk = koza_tmp.getx() + koza_tmp.getdlzka() * Math.cos(Math.toRadians(koza_tmp.getuhol()));
			        double yk = koza_tmp.gety() + koza_tmp.getdlzka() * Math.sin(Math.toRadians(koza_tmp.getuhol()));
			        
			        double ax = (xk - arg0.getPoint().getX()) * (xk - arg0.getPoint().getX());
					double ay = (yk - arg0.getPoint().getY()) * (yk - arg0.getPoint().getY());
					double dlzkaa =  Math.sqrt(ax + ay);
					
					double uholl = Math.atan2( arg0.getPoint().getY() - yk , arg0.getPoint().getX() - xk )* 180 / Math.PI;
					koza_tmp.pridaj_dalsiu(dlzkaa, uholl);
				}
				repaint();
			}
		}else if (parent.mod == 3){
			
			if (parent.root_kost != null){
				kost oznac;
				oznac = parent.root_kost.oznacena(arg0.getPoint().getX(),arg0.getPoint().getY());
				if (oznac != null){
					parent.animacia_oznacena = oznac;
					repaint();
					
				}
			}
		}
	
		stlacena_mys = true;
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		stlacena_mys = false;
		
	}
	
	@Override
	public void mouseMoved(MouseEvent arg0) {
		//
	}

	@Override
	public void mouseDragged(MouseEvent arg0) {
		if (parent.mod == 0){
				if (stlacena_mys){
					if ( parent.oznacena != null){
						double xn = parent.oznacena.getx();
				        double yn = parent.oznacena.gety();
						
						double ax = (xn - arg0.getPoint().getX()) * (xn - arg0.getPoint().getX());
						double ay = (yn - arg0.getPoint().getY()) * (yn - arg0.getPoint().getY());
						double dlzkaa =  Math.sqrt(ax + ay);
						
						double uholl = Math.atan2( arg0.getPoint().getY() - yn , arg0.getPoint().getX() - xn )* 180 / Math.PI;
		
						parent.oznacena.posun(dlzkaa,uholl);
						parent.posunula_sa_kost();
						repaint();
						
					}
				}
		
		}else if (parent.mod == 1){
			if (stlacena_mys){
				if (parent.oznacena_koza != null){
					double xn = parent.oznacena_koza.getx();
			        double yn = parent.oznacena_koza.gety();
			        
			        double ax = (xn - arg0.getPoint().getX()) * (xn - arg0.getPoint().getX());
					double ay = (yn - arg0.getPoint().getY()) * (yn - arg0.getPoint().getY());
					double dlzkaa =  Math.sqrt(ax + ay);
					
					double uholl = Math.atan2( arg0.getPoint().getY() - yn , arg0.getPoint().getX() - xn )* 180 / Math.PI;
	
					parent.oznacena_koza.posun(dlzkaa,uholl);
					repaint();
				}

			}
				
			
		}else if (parent.mod == 3){
			if (stlacena_mys){
				if (parent.animacia_oznacena != null){
					double xn = parent.animacia_oznacena.getx();
			        double yn = parent.animacia_oznacena.gety();
			        
					double uholl = Math.atan2( arg0.getPoint().getY() - yn , arg0.getPoint().getX() - xn )* 180 / Math.PI;
	
					parent.animacia_oznacena.posun_animacia(uholl);
					parent.posunula_sa_kost();
					parent.prepocitaj_kozu(parent.animacia_oznacena.getmeno());
					parent.root_kost.vymaz_maticu();
					repaint();
				}

			}
				
			
		}
	}
	
}