import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.text.html.MinimalHTMLWriter;


public class kost {
	
	private boolean skryta;
	private double x;
	private double y;
	private double dlzka;
	private int hrubka;
	private double uhol;
	private double uhol_min;
	private double uhol_max;
	private ArrayList<kost> deti;
	
	private matica_pohybu maticaPohybu;
	
	private String meno;
	private Color farba;
	
	public kost(){
		x = 0;
		y = 0;
		dlzka = 0;
		meno = "";
		hrubka = 2;
		uhol = 90;
		uhol_min = 0;
		uhol_max = 180;
		deti = new ArrayList<kost>();
		skryta = false;
		farba = Color.black;
		maticaPohybu = new matica_pohybu();
		
	}
	
	public kost(double xx, double yy, String menoo, double dlzkaa, int hrubkaa, double uholl, double uhol_minn, double uhol_maxx, boolean skrytaa,Color farbaa){
		x = xx;
		y = yy;
		meno = menoo;
		dlzka = dlzkaa;
		hrubka = hrubkaa;
		uhol = uholl;
		uhol_min = uhol_minn;
		uhol_max = uhol_maxx;
		deti = new ArrayList<kost>();
		skryta = skrytaa;
		farba = farbaa;
		maticaPohybu = new matica_pohybu();
	}
	
	public kost(double xx, double yy,double dlzkaa, double uholl){
		x = xx;
		y = yy;
		dlzka = dlzkaa;
		meno = "";
		hrubka = 2;
		uhol = uholl;
		uhol_min = uholl+180-45;
		uhol_max = uholl+180+45;
		deti = null;
		skryta = false;
		farba = Color.black;
		maticaPohybu = new matica_pohybu();
		
	}
	
	public void pridaj(String menoo, double dlzkaa, int hrubkaa, double uholl, double uhol_minn, double uhol_maxx, Color farbaa){
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
        
		deti.add(new kost(xn,yn,menoo,dlzkaa,hrubkaa,uholl,uhol_minn,uhol_maxx,false, farbaa));
	}
	
	
	
	public void kresli(Graphics2D g2, kost oznacena, kost animacia_oznacena){
		//System.out.print("Kreslim kost " + meno + " uhol: "+ uhol + " dlzka:"+ dlzka + "\n");
		//System.out.print("Kreslim kost " + meno + "\n");
		
		if (!skryta){
			g2.setPaint (Color.black);
			if (this == oznacena){
				g2.setPaint (Color.green);
			}
			if (this == animacia_oznacena){
				g2.setPaint (Color.blue);
			}
			g2.setStroke(new BasicStroke(hrubka, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
			
			
			double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
	        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
	
			g2.drawLine((int)x,(int)y,(int)xn,(int)yn);
			
			//vykreslenie "klbov"
			g2.setPaint (Color.red);
			g2.drawOval((int)x-hrubka/2, (int)y-hrubka/2, hrubka, hrubka);
			g2.setPaint (Color.MAGENTA);
			if (this == oznacena){
				g2.setPaint (Color.green);
			}
			if (this == animacia_oznacena){
				g2.setPaint (Color.blue);
			}
			g2.drawOval((int)xn-hrubka/2, (int)yn-hrubka/2, hrubka, hrubka);
			
		}
		
		if (deti.size() > 0){
			for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
			    iter.next().kresli(g2,oznacena,animacia_oznacena);
			}
			
		}
		
	}
	
	public kost oznacena(double ox, double oy){
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
		
		if ((ox > xn-hrubka) && (oy > yn-hrubka) && (ox < xn+hrubka) && (oy < yn+hrubka) ){
			//System.out.print("Oznacena " + meno + " uhol: "+ uhol + " dlzka:"+ dlzka + " x:" + xn + " y:" + yn +  "\n");
			System.out.print("Oznacena " + meno + "\n");
			return this;
		}else{
			kost vrat = null;
			for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
			    if (vrat== null){ 
			    	vrat = iter.next().oznacena(ox,oy);
			    }else{
			    	iter.next();
			    }
			}
			return vrat;
			
		}
		
	}
	
	public void posun(double dlzkaa, double uholl){
		
		//int uhol_tmp = uhol;
		//double dlzka_tmp = dlzka;
		dlzka = dlzkaa;
		uhol = uholl;
		posun_deti();
		
	}
	
	public void posun_animacia(double uholl){
		
		if ((uholl+180 > uhol_min) && (uholl+180 < uhol_max)){
			
			double uhol_tmp = uhol;
			double u =  (uholl-uhol) * Math.PI / 180;
			
			maticaPohybu.setA(Math.cos(u));
			maticaPohybu.setB(Math.sin(u));
			maticaPohybu.setC(-Math.sin(u));
			maticaPohybu.setD(Math.cos(u));
			maticaPohybu.setTx(-x*Math.cos(u) + y*Math.sin(u) + x);
			maticaPohybu.setTy(-x*Math.sin(u) - y*Math.cos(u) + y);
			
			uhol = uholl;
			
			posun_deti_animacia(uholl-uhol_tmp, x,y);
		
		}
		
		
	}
	
	
	private void posun_deti_animacia(double uholl,double xx, double yy){
		
		double u =  uholl * Math.PI / 180;
		
		maticaPohybu.setA(Math.cos(u));
		maticaPohybu.setB(Math.sin(u));
		maticaPohybu.setC(-Math.sin(u));
		maticaPohybu.setD(Math.cos(u));
		maticaPohybu.setTx(-xx*Math.cos(u) + yy*Math.sin(u) + xx);
		maticaPohybu.setTy(-xx*Math.sin(u) - yy*Math.cos(u) + yy);
		
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
		
        //double xnn = maticaPohybu.getA()*xn+maticaPohybu.getC()*yn+maticaPohybu.getTx();
		//double ynn = maticaPohybu.getB()*yn+maticaPohybu.getD()*yn+maticaPohybu.getTy();
        
        kost tmp = null;
		for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
			tmp = iter.next();
			
			tmp.uhol +=uholl;
			tmp.x = xn;
			tmp.y = yn;
			tmp.posun_deti_animacia(uholl, xx, yy);
		}
				
	}

	
	private void posun_deti(){
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
		
        kost tmp = null;
		for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
			tmp = iter.next();
			
			tmp.x = xn;
			tmp.y = yn;
			tmp.posun_deti();
		}
				
	}
	
	
	public String getmeno(){
		return meno;	
	}
	public double getx(){
		return x;	
	}
	public double gety(){
		return y;	
	}
	public double getdlzka(){
		return dlzka;	
	}
	public double getuhol(){
		return uhol;	
	}
	public double getuhol_min(){
		return uhol_min;	
	}
	public double getuhol_max(){
		return uhol_max;	
	}
	
	public void setuhol(double uholl){
		uhol = uholl;	
	}
	
	public void setuhol_min(double uhol){
		uhol_min = uhol;	
	}
	public void setuhol_max(double uhol){
		uhol_max = uhol;	
	}
	
	public kost getprvedieta(){
		if (!deti.isEmpty()){
			return deti.get(0);
		}
		return null;
	}
	
	public kost getdieta(int cislo){
		if (deti.size() >= cislo){
			return deti.get(0);
		}
		return null;
	}
	
	public kost getdieta(String menoo){
		
		if (meno.equals(menoo) ){
			return this;
		}else{
			kost vrat = null;
			for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
			    if (vrat== null){ 
			    	vrat = iter.next().getdieta(menoo);
			    }else{
			    	iter.next();
			    }
			}
			return vrat;
			
		}
	}
		
	public String DoStringu(String meno_otca){
		String ret = "";
		ret += "k;" + meno_otca + ";" + skryta + ";" + x + ";" + y  + ";" + dlzka + ";" +  hrubka  + ";" +  uhol  + ";" +   uhol_min  + ";" +  uhol_max  + ";" +  meno + ";";
		ret += farba.getRed()+ ";" + farba.getGreen()+ ";" + farba.getBlue()+ "\n";
		
		for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
			ret += iter.next().DoStringu(meno);
		}
		
		
		return ret;
		
	}
	
	public void odstran_dieta(kost dieta){
		
		for (int i=0; i<deti.size(); i++) {
			if (deti.get(i).meno.equals(dieta.meno)){
				deti.remove(i);
				return;
			}
		}
			
		
		for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
		    	iter.next().odstran_dieta(dieta);
		    }

		
	}
	
	public double vzdialenost(double xx, double yy){
		
		double xn = x + dlzka * Math.cos(Math.toRadians(uhol));
        double yn = y + dlzka * Math.sin(Math.toRadians(uhol));
		
		return Math.sqrt((xn-xx)*(xn-xx) + (yn-yy)*(yn-yy)); 
	}

	

	public Color getFarba(){
		return farba;
	}
	public void setFarba(Color c){
		farba = c;
	}
	
	public int deti_size(){
		return deti.size();
	}
	
	/*public ArrayList<double_string> vzdialenosti(double xx, double yy){
		ArrayList<double_string> vzdial = new ArrayList<double_string>();
		for (int i=0; i < deti_size(); i++) {
			//vzdial.addAll(getdieta(i).vzdialenosti(xx, yy));
			//vzdial.add(new double_string(vzdialenost(xx,yy),meno));
			
		}
		return vzdial;
		
	}*/
	public ArrayList<double_string> vzdialenosti(double xx, double yy, ArrayList<double_string> vzdialenosti){

		for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
	    	iter.next().vzdialenosti(xx, yy,vzdialenosti);
	    }
		vzdialenosti.add(new double_string(vzdialenost(xx,yy),meno));
		return vzdialenosti;
		
	}
	
	public void vymaz_maticu(){
		maticaPohybu.vymaz();
		for (Iterator<kost> iter = deti.iterator(); iter.hasNext();  ) {
	    	iter.next().vymaz_maticu();
	    }
	}
	
	public matica_pohybu getMaticuPohybu(){
		return maticaPohybu;
	}
}
